"""
 Module de test des classes et fonctions DoFn
"""
from unittest import TestCase
from testfixtures import LogCapture
from dataflow.batch.dofn.formatcolumn import FormatColumnDoFn
from utils.utils import get_schema_from_json


class FormatColumnDoFnTest(TestCase):
    """
        Classe pour tester le formatage des donnees issues de la Raw Layer 2
    """

    def setUp(self):
        self.schema_dict_ = get_schema_from_json('resources/bq/DDL/schema/shop_retail.json')

        self.dofn = FormatColumnDoFn()

    # tester le bon format et les bonnes valeurs
    def test_values_columns(self):
        row_test = dict(prefixe="SHOP1",
                        shop1_cou_code="FR",
                        shop1_shp_number="0563",
                        shop1_shp_name="SEVRAN VILLEPINTE",
                        shop1_comimp_code="CC",
                        shop1_shp_main_number="0563",
                        shop1_indic_eq_lpg="F",
                        shop1_indic_top50="F",
                        shop1_indic_surface_egale='',
                        shop1_add_way_1='',
                        shop1_add_way_2="Route des Petits Ponts",
                        shop1_add_way_3="Centre Commercial Carrefour",
                        shop1_pos_pstare_code="93270",
                        shop1_add_locality="SEVRAN",
                        shop1_add_phone_number_1="0143102121",
                        shop1_cou_name="France",
                        shop1_cur_code="EU",
                        shop1_cur_name="Euro",
                        shop1_lan_code="FRA",
                        shop1_sec_code="22",
                        shop1_sec_name="Secteur 22",
                        shop1_sec_organizer_code=19,
                        shop1_reg_code="02",
                        shop1_reg_name="Nord",
                        shop1_reg_director_code="102",
                        shop1_shp_open_flag="1",
                        shop1_shp_test_flag='',
                        shop1_cou_code2="France",
                        shop1_shp_code="FR 0563",
                        shop1_ismcat_code="13",
                        shop1_shprsp_code="18183",
                        shop1_rrspshp_dentry_date="20141126",
                        shop1_ccl_email="sarlapybbeaute@gmail.com",
                        shop1_gesmod_code="8",
                        shop1_gesmod_lib="Gerance Exclusif",
                        shop1_shp_cur_generation="60",
                        shop1_shp_cur_generation_name="Meubles",
                        shop1_comimp_name="Centre commercial",
                        shop1_ismcat_name="CC banlieues pop",
                        shop1_ind_shp_ins_dep="true",
                        shop1_ind_shp_ins_dep_name='',
                        shop1_inst_dep="true",
                        shop1_mag_princ='',
                        shop1_weeday_name="dimanche",
                        shop1_genhis_date="20120822",
                        shop1_loc_retail_outlet_nbr="1.0",
                        shop1_loc_locality="SEVRAN",
                        shop1_acz_name="Zone C",
                        shop1_tou_label="Autre",
                        shop1_shp_tot_cust_area_population="141550.0",
                        shop1_shp_yr_tot_cust_area_popul='',
                        shop1_cust_area_type_name="Tres grande ville 100 - 300 000 habitants",
                        shop1_leader_sign_name="Carrefour",
                        shop1_sec_organizer_name="Sylvie JOLAK",
                        shop1_reg_directore_name="Isabelle DONAT",
                        shop1_shp_open_date="19841106",
                        shop1_shp_recre_date="19841106",
                        shop1_shp_trans_date='',
                        shop1_shp_exten_date='',
                        shop1_shp_renovation_date="20120625",
                        shop1_shp_close_date='',
                        shop1_shp_cur_rsp_name="BROCHARD PEGGY",
                        shop1_physdsc_sale_surface="73.45",
                        shop1_physdsc_cabin_surface="24.7",
                        shop1_tcbcfg_name="T13 =Config T11 + 2 postes d'encaissement supplementaires",
                        shop1_invmod_code="01",
                        shop1_lglsts_code="02",
                        shop1_shp_cur_dim="Y",
                        shop1_creation_date="20190621",
                        shop1_system_last_update="20190621",
                        shop1_loc_population_quantity="47029.0",
                        shop1_cust_area_type_code="04",
                        shop1_sitqlt_code='',
                        shop1_sitqlt_name='',
                        shop1_shp_numeris="0143102121",
                        shop1_shp_fax="0143102122",
                        shop1_shp_equivalent_effective="5.0",
                        shop1_shp_total_area="125.7",
                        shop1_shp_rsv_surface="7.3",
                        shop1_shp_window_number="2.0",
                        shop1_shp_window_width="3.32",
                        shop1_shp_floor_number="0.0",
                        shop1_shp_ctr_end_date="21001231",
                        shop1_shp_rent_amount='',
                        shop1_shp_lglsts_name="Gerance",
                        shop1_shp_invmod_name="Exclusif",
                        shop1_shp_com_ratio='',
                        shop1_shp_ctr_nbr="CT7104",
                        shop1_shp_lease_amount='',
                        shop1_shp_invoiced_flag="Y",
                        shop1_ctr_third_number="1805636",
                        shop1_shp_fr_ville="SEVRAN",
                        shop1_add_acc_name="Frederic MARTIN",
                        shop1_add_acc_way1='',
                        shop1_add_acc_way2="RESIDENCE ST DONAT",
                        shop1_add_acc_way3="5 CHEMIN ST DONAT",
                        shop1_add_acc_pos_pstare_code='',
                        shop1_add_acc_locality="AIX EN PROVENCE",
                        shop1_add_acc_phone_number_1="0651370730",
                        shop1_add_acc_country='',
                        shop1_shprsp_title="2",
                        shop1_shprsp_first_name="PEGGY",
                        shop1_shprsp_birthday="19811031",
                        shop1_ctr_effect_date="20141126",
                        shop1_shp_fiscal_close_date="20180331",
                        shop1_phydsc_fro_width_1="6.84",
                        shop1_phydsc_fro_width_2='',
                        shop1_phydsc_fro_width_3='',
                        shop1_cor_code="103424",
                        shop1_cor_lgl_type="SR",
                        shop1_cor_name="SARL APY.B BEAUTE",
                        shop1_cabin_qty="3",
                        shop1_rrspshp_resumption_date="20141126",
                        shop1_ctr_type_name="FRANCE CONTRAT V5 GL ANN2",
                        shop1_ctr_denunciation_date='',
                        shop1_ctr_royalties_cabin='',
                        shop1_ctr_deadline_preavis="20170524",
                        shop1_ech_datecomite='',
                        shop1_ech_decision='',
                        shop1_ech_dateservice='',
                        shop1_cau_number="10",
                        shop1_shp_certifie_flag='',
                        shop1_ctr_duration="3.0",
                        shop1_ctr_number_cabin='',
                        shop1_regdev_code='',
                        shop1_regdev_name='',
                        shop1_add_cou_code="FR",
                        shop1_add_del_way_1="CENTRE DE BEAUTE YVES ROCHER",
                        shop1_add_del_way_2="CENTRE COMMERCIAL CARREFOUR",
                        shop1_add_del_way_3="ROUTE DES PETITS PONTS",
                        shop1_add_del_pos_pstare_code="93270",
                        shop1_add_del_locality="SEVRAN",
                        shop1_add_del_loc_code='',
                        shop1_add_del_cou_code="FR",
                        shop1_add_del_country="France",
                        shop1_add_del_phone_number_1='',
                        shop1_trpreg_code="P1",
                        shop1_trpreg_name="Paris",
                        shop1_shp_ss_gen="60",
                        shop1_shp_ss_gen_lib="ACV",
                        shop1_lzn_code="75056",
                        shop1_lzn_name="Paris",
                        shop1_shp_fidprogram_accepted="1.0",
                        shor1_tim_cou_code='',
                        shor1_tim_shp_number='',
                        shor1_tim_weeday_code='',
                        shor1_tim_begin_morning='',
                        shor1_tim_end_morning='',
                        shor1_tim_begin_afternoon='',
                        shor1_tim_end_afternoon='',
                        ssct1_sec_cou_code='',
                        ssct1_sec_code='',
                        ssct1_sec_name='',
                        ssct1_seg_reg_code='',
                        ssct1_sec_organizer_code='',
                        ssct1_sec_people_tcb_code='',
                        ssct1_sec_people_name='',
                        srgn1_reg_cou_code='',
                        srgn1_reg_code='',
                        srgn1_reg_name='',
                        srgn1_reg_director_code='',
                        srgn1_reg_people_tcb_code='',
                        srgn1_reg_people_name='',
                        scfg1_mchfam_cou_code='',
                        scfg1_mchfam_shp_code='',
                        scfg1_mchfam_mcf_code='',
                        scfg1_mchfam_mcf_name='',
                        scfg1_mchfam_mchfam_code='',
                        scfg1_mchfam_mchfam_name='',
                        strs1_transf_cou_code='',
                        strs1_transf_shp_number='',
                        strs1_transf_code='',
                        strs1_transf_label='',
                        strs1_transf_open_date='',
                        strs1_transf_wor_begin='',
                        strs1_transf_wor_end_date='',
                        strs1_transf_tem_close='',
                        strs1_transf_ope_aft_work='',
                        strs1_transf_close_date='',
                        strs1_transf_activity_flag='',
                        strs1_transf_comment='',
                        strs1_transf_creation_date='',
                        sctr1_ctr_cou_code='',
                        sctr1_ctr_shp_number='',
                        sctr1_ctr_nbr='',
                        sctr1_ctr_sequence_nbr='',
                        sctr1_ctr_invmod_code='',
                        sctr1_ctr_effect_date='',
                        sctr1_ctr_end_date='',
                        sctr1_ctr_third_number='',
                        sctr1_ctr_code_type_gestion='',
                        sctr1_ctr_cor_name='',
                        sctd1_cou_code='',
                        sctd1_ctd_ctr_nbr='',
                        sctd1_ctd_ctr_sequence_nbr='',
                        sctd1_ctd_start_date='',
                        sctd1_ctd_end_date='',
                        sctd1_ctd_dis_code='',
                        sctd1_ctd_ctd_rate='',
                        sctt1_cou_code='',
                        sctt1_ctx_ctr_nbr='',
                        sctt1_ctx_ctr_sequence_nbr='',
                        sctt1_ctx_start_date='',
                        sctt1_ctx_end_date='',
                        sctt1_ctx_tax_code='',
                        sctt1_ctx_rate='',
                        sshr1_cou_code='',
                        sshr1_shp_number='',
                        sshr1_shprsp_code='',
                        sshr1_shprsp_dentry_date='',
                        sshr1_shprsp_end='',
                        sshr1_rrspshp_resumption_date='',
                        sshr1_shprsp_email='',
                        sshr1_shprsp_name='',
                        sshr1_shprsp_first_name='',
                        version_number="616",
                        source_file_name="REF_RES_LYR_YRFR_B_SHP_20190621104205.txt",
                        processing_time="2019-06-27 13 = 50 = 46.404 UTC"
                        )

        parsed_line = self.dofn.process(row_test, self.schema_dict_).next()

        self.assertEqual(parsed_line['shop1_add_way_2'], 'Route des Petits Ponts')
        self.assertEqual(parsed_line['shop1_add_way_3'], 'Centre Commercial Carrefour')
        self.assertEqual(parsed_line['shop1_pos_pstare_code'], '93270')
        self.assertEqual(parsed_line['shop1_add_locality'], 'SEVRAN')
        self.assertEqual(parsed_line['shop1_add_phone_number_1'], '0143102121')
        self.assertEqual(parsed_line['shop1_cou_name'], 'France')
        self.assertEqual(parsed_line['shop1_cur_code'], 'EU')
        self.assertEqual(parsed_line['shop1_cur_name'], 'Euro')
        self.assertEqual(parsed_line['shop1_lan_code'], 'FRA')
        self.assertEqual(parsed_line['shop1_sec_code'], '22')
        self.assertEqual(parsed_line['shop1_sec_name'], 'Secteur 22')
        self.assertEqual(parsed_line['shop1_sec_organizer_code'], 19)
        self.assertEqual(parsed_line['shop1_ccl_email'], 'sarlapybbeaute@gmail.com')

    # Tester si une valeur est vide

    def test_empty_values(self):
        """

        :return:
        """
        row_test = dict(prefixe="SHOP1",
                        shop1_cou_code="FR",
                        shop1_shp_number="0563",
                        shop1_shp_name="SEVRAN VILLEPINTE",
                        shop1_comimp_code="CC",
                        shop1_shp_main_number="0563",
                        shop1_indic_eq_lpg="F",
                        shop1_indic_top50="F",
                        shop1_indic_surface_egale='',
                        shop1_add_way_1='',
                        shop1_add_way_2="Route des Petits Ponts",
                        shop1_add_way_3="Centre Commercial Carrefour",
                        shop1_pos_pstare_code="93270",
                        shop1_add_locality="SEVRAN",
                        shop1_add_phone_number_1="0143102121",
                        shop1_cou_name="France",
                        shop1_cur_code="EU",
                        shop1_cur_name="Euro",
                        shop1_lan_code="FRA",
                        shop1_sec_code="22",
                        shop1_sec_name="Secteur 22",
                        shop1_sec_organizer_code=19,
                        shop1_reg_code="02",
                        shop1_reg_name="Nord",
                        shop1_reg_director_code="102",
                        shop1_shp_open_flag="1",
                        shop1_shp_test_flag='',
                        shop1_cou_code2="France",
                        shop1_shp_code="FR 0563",
                        shop1_ismcat_code="13",
                        shop1_shprsp_code="18183",
                        shop1_rrspshp_dentry_date="20141126",
                        shop1_ccl_email="sarlapybbeaute@gmail.com",
                        shop1_gesmod_code="8",
                        shop1_gesmod_lib="Gerance Exclusif",
                        shop1_shp_cur_generation="60",
                        shop1_shp_cur_generation_name="Meubles",
                        shop1_comimp_name="Centre commercial",
                        shop1_ismcat_name="CC banlieues pop",
                        shop1_ind_shp_ins_dep="true",
                        shop1_ind_shp_ins_dep_name='',
                        shop1_inst_dep="true",
                        shop1_mag_princ='',
                        shop1_weeday_name="dimanche",
                        shop1_genhis_date="20120822",
                        shop1_loc_retail_outlet_nbr="1.0",
                        shop1_loc_locality="SEVRAN",
                        shop1_acz_name="Zone C",
                        shop1_tou_label="Autre",
                        shop1_shp_tot_cust_area_population="141550.0",
                        shop1_shp_yr_tot_cust_area_popul='',
                        shop1_cust_area_type_name="Tres grande ville 100 - 300 000 habitants",
                        shop1_leader_sign_name="Carrefour",
                        shop1_sec_organizer_name="Sylvie JOLAK",
                        shop1_reg_directore_name="Isabelle DONAT",
                        shop1_shp_open_date="19841106",
                        shop1_shp_recre_date="19841106",
                        shop1_shp_trans_date='',
                        shop1_shp_exten_date='',
                        shop1_shp_renovation_date="20120625",
                        shop1_shp_close_date='',
                        shop1_shp_cur_rsp_name="BROCHARD PEGGY",
                        shop1_physdsc_sale_surface="73.45",
                        shop1_physdsc_cabin_surface="24.7",
                        shop1_tcbcfg_name="T13 =Config T11 + 2 postes d'encaissement supplementaires",
                        shop1_invmod_code="01",
                        shop1_lglsts_code="02",
                        shop1_shp_cur_dim="Y",
                        shop1_creation_date="20190621",
                        shop1_system_last_update="20190621",
                        shop1_loc_population_quantity="47029.0",
                        shop1_cust_area_type_code="04",
                        shop1_sitqlt_code='',
                        shop1_sitqlt_name='',
                        shop1_shp_numeris="0143102121",
                        shop1_shp_fax="0143102122",
                        shop1_shp_equivalent_effective="5.0",
                        shop1_shp_total_area="125.7",
                        shop1_shp_rsv_surface="7.3",
                        shop1_shp_window_number="2.0",
                        shop1_shp_window_width="3.32",
                        shop1_shp_floor_number="0.0",
                        shop1_shp_ctr_end_date="21001231",
                        shop1_shp_rent_amount='',
                        shop1_shp_lglsts_name="Gerance",
                        shop1_shp_invmod_name="Exclusif",
                        shop1_shp_com_ratio='',
                        shop1_shp_ctr_nbr="CT7104",
                        shop1_shp_lease_amount='',
                        shop1_shp_invoiced_flag="Y",
                        shop1_ctr_third_number="1805636",
                        shop1_shp_fr_ville="SEVRAN",
                        shop1_add_acc_name="Frederic MARTIN",
                        shop1_add_acc_way1='',
                        shop1_add_acc_way2="RESIDENCE ST DONAT",
                        shop1_add_acc_way3="5 CHEMIN ST DONAT",
                        shop1_add_acc_pos_pstare_code='',
                        shop1_add_acc_locality="AIX EN PROVENCE",
                        shop1_add_acc_phone_number_1="0651370730",
                        shop1_add_acc_country='',
                        shop1_shprsp_title="2",
                        shop1_shprsp_first_name="PEGGY",
                        shop1_shprsp_birthday="19811031",
                        shop1_ctr_effect_date="20141126",
                        shop1_shp_fiscal_close_date="20180331",
                        shop1_phydsc_fro_width_1="6.84",
                        shop1_phydsc_fro_width_2='',
                        shop1_phydsc_fro_width_3='',
                        shop1_cor_code="103424",
                        shop1_cor_lgl_type="SR",
                        shop1_cor_name="SARL APY.B BEAUTE",
                        shop1_cabin_qty="3",
                        shop1_rrspshp_resumption_date="20141126",
                        shop1_ctr_type_name="FRANCE CONTRAT V5 GL ANN2",
                        shop1_ctr_denunciation_date='',
                        shop1_ctr_royalties_cabin='',
                        shop1_ctr_deadline_preavis="20170524",
                        shop1_ech_datecomite='',
                        shop1_ech_decision='',
                        shop1_ech_dateservice='',
                        shop1_cau_number="10",
                        shop1_shp_certifie_flag='',
                        shop1_ctr_duration="3.0",
                        shop1_ctr_number_cabin='',
                        shop1_regdev_code='',
                        shop1_regdev_name='',
                        shop1_add_cou_code="FR",
                        shop1_add_del_way_1="CENTRE DE BEAUTE YVES ROCHER",
                        shop1_add_del_way_2="CENTRE COMMERCIAL CARREFOUR",
                        shop1_add_del_way_3="ROUTE DES PETITS PONTS",
                        shop1_add_del_pos_pstare_code="93270",
                        shop1_add_del_locality="SEVRAN",
                        shop1_add_del_loc_code='',
                        shop1_add_del_cou_code="FR",
                        shop1_add_del_country="France",
                        shop1_add_del_phone_number_1='',
                        shop1_trpreg_code="P1",
                        shop1_trpreg_name="Paris",
                        shop1_shp_ss_gen="60",
                        shop1_shp_ss_gen_lib="ACV",
                        shop1_lzn_code="75056",
                        shop1_lzn_name="Paris",
                        shop1_shp_fidprogram_accepted="1.0",
                        shor1_tim_cou_code='',
                        shor1_tim_shp_number='',
                        shor1_tim_weeday_code='',
                        shor1_tim_begin_morning='',
                        shor1_tim_end_morning='',
                        shor1_tim_begin_afternoon='',
                        shor1_tim_end_afternoon='',
                        ssct1_sec_cou_code='',
                        ssct1_sec_code='',
                        ssct1_sec_name='',
                        ssct1_seg_reg_code='',
                        ssct1_sec_organizer_code='',
                        ssct1_sec_people_tcb_code='',
                        ssct1_sec_people_name='',
                        srgn1_reg_cou_code='',
                        srgn1_reg_code='',
                        srgn1_reg_name='',
                        srgn1_reg_director_code='',
                        srgn1_reg_people_tcb_code='',
                        srgn1_reg_people_name='',
                        scfg1_mchfam_cou_code='',
                        scfg1_mchfam_shp_code='',
                        scfg1_mchfam_mcf_code='',
                        scfg1_mchfam_mcf_name='',
                        scfg1_mchfam_mchfam_code='',
                        scfg1_mchfam_mchfam_name='',
                        strs1_transf_cou_code='',
                        strs1_transf_shp_number='',
                        strs1_transf_code='',
                        strs1_transf_label='',
                        strs1_transf_open_date='',
                        strs1_transf_wor_begin='',
                        strs1_transf_wor_end_date='',
                        strs1_transf_tem_close='',
                        strs1_transf_ope_aft_work='',
                        strs1_transf_close_date='',
                        strs1_transf_activity_flag='',
                        strs1_transf_comment='',
                        strs1_transf_creation_date='',
                        sctr1_ctr_cou_code='',
                        sctr1_ctr_shp_number='',
                        sctr1_ctr_nbr='',
                        sctr1_ctr_sequence_nbr='',
                        sctr1_ctr_invmod_code='',
                        sctr1_ctr_effect_date='',
                        sctr1_ctr_end_date='',
                        sctr1_ctr_third_number='',
                        sctr1_ctr_code_type_gestion='',
                        sctr1_ctr_cor_name='',
                        sctd1_cou_code='',
                        sctd1_ctd_ctr_nbr='',
                        sctd1_ctd_ctr_sequence_nbr='',
                        sctd1_ctd_start_date='',
                        sctd1_ctd_end_date='',
                        sctd1_ctd_dis_code='',
                        sctd1_ctd_ctd_rate='',
                        sctt1_cou_code='',
                        sctt1_ctx_ctr_nbr='',
                        sctt1_ctx_ctr_sequence_nbr='',
                        sctt1_ctx_start_date='',
                        sctt1_ctx_end_date='',
                        sctt1_ctx_tax_code='',
                        sctt1_ctx_rate='',
                        sshr1_cou_code='',
                        sshr1_shp_number='',
                        sshr1_shprsp_code='',
                        sshr1_shprsp_dentry_date='',
                        sshr1_shprsp_end='',
                        sshr1_rrspshp_resumption_date='',
                        sshr1_shprsp_email='',
                        sshr1_shprsp_name='',
                        sshr1_shprsp_first_name='',
                        version_number="616",
                        source_file_name="REF_RES_LYR_YRFR_B_SHP_20190621104205.txt",
                        processing_time="2019-06-27 13 = 50 = 46.404 UTC"
                        )
        row_test = self.dofn.process(row_test, self.schema_dict_)

        for row in row_test:
            self.assertFalse('sshr1_shp_number' in row)
            self.assertFalse('srgn1_reg_cou_code' in row)
            self.assertFalse('sctt1_ctx_ctr_sequence_nbr' in row)


    def test_format_columns(self):
        """
            on teste un enregistrement correct :
            toutes les zones doivent avoir le format (string, int, float ... attendu)
        :return:
        """
        row_test = dict(prefixe="SHOP1",
                        shop1_cou_code="FR",
                        shop1_shp_number="0563",
                        shop1_shp_name="SEVRAN VILLEPINTE",
                        shop1_comimp_code="CC",
                        shop1_shp_main_number="0563",
                        shop1_indic_eq_lpg="F",
                        shop1_indic_top50="F",
                        shop1_indic_surface_egale='',
                        shop1_add_way_1='',
                        shop1_add_way_2="Route des Petits Ponts",
                        shop1_add_way_3="Centre Commercial Carrefour",
                        shop1_pos_pstare_code="93270",
                        shop1_add_locality="SEVRAN",
                        shop1_add_phone_number_1="0143102121",
                        shop1_cou_name="France",
                        shop1_cur_code="EU",
                        shop1_cur_name="Euro",
                        shop1_lan_code="FRA",
                        shop1_sec_code="22",
                        shop1_sec_name="Secteur 22",
                        shop1_sec_organizer_code=19,
                        shop1_reg_code="02",
                        shop1_reg_name="Nord",
                        shop1_reg_director_code="102",
                        shop1_shp_open_flag="1",
                        shop1_shp_test_flag='',
                        shop1_cou_code2="France",
                        shop1_shp_code="FR 0563",
                        shop1_ismcat_code="13",
                        shop1_shprsp_code="18183",
                        shop1_rrspshp_dentry_date="20141126",
                        shop1_ccl_email="sarlapybbeaute@gmail.com",
                        shop1_gesmod_code="8",
                        shop1_gesmod_lib="Gerance Exclusif",
                        shop1_shp_cur_generation="60",
                        shop1_shp_cur_generation_name="Meubles",
                        shop1_comimp_name="Centre commercial",
                        shop1_ismcat_name="CC banlieues pop",
                        shop1_ind_shp_ins_dep="True",
                        shop1_ind_shp_ins_dep_name="True",
                        shop1_inst_dep=True,
                        shop1_mag_princ='',
                        shop1_weeday_name="dimanche",
                        shop1_genhis_date="20120822",
                        shop1_loc_retail_outlet_nbr="1.0",
                        shop1_loc_locality="SEVRAN",
                        shop1_acz_name="Zone C",
                        shop1_tou_label="Autre",
                        shop1_shp_tot_cust_area_population="141550.0",
                        shop1_shp_yr_tot_cust_area_popul='',
                        shop1_cust_area_type_name="Tres grande ville 100 - 300 000 habitants",
                        shop1_leader_sign_name="Carrefour",
                        shop1_sec_organizer_name="Sylvie JOLAK",
                        shop1_reg_directore_name="Isabelle DONAT",
                        shop1_shp_open_date="19841106",
                        shop1_shp_recre_date="19841106",
                        shop1_shp_trans_date='',
                        shop1_shp_exten_date='',
                        shop1_shp_renovation_date="20120625",
                        shop1_shp_close_date='',
                        shop1_shp_cur_rsp_name="BROCHARD PEGGY",
                        shop1_physdsc_sale_surface="73.45",
                        shop1_physdsc_cabin_surface="24.7",
                        shop1_tcbcfg_name="T13 =Config T11 + 2 postes d'encaissement supplementaires",
                        shop1_invmod_code="01",
                        shop1_lglsts_code="02",
                        shop1_shp_cur_dim="Y",
                        shop1_creation_date="20190621",
                        shop1_system_last_update="20190621",
                        shop1_loc_population_quantity="47029.0",
                        shop1_cust_area_type_code="04",
                        shop1_sitqlt_code='',
                        shop1_sitqlt_name='',
                        shop1_shp_numeris="0143102121",
                        shop1_shp_fax="0143102122",
                        shop1_shp_equivalent_effective="5.0",
                        shop1_shp_total_area="125.7",
                        shop1_shp_rsv_surface="7.3",
                        shop1_shp_window_number="2.0",
                        shop1_shp_window_width="3.32",
                        shop1_shp_floor_number="0.0",
                        shop1_shp_ctr_end_date="21001231",
                        shop1_shp_rent_amount='',
                        shop1_shp_lglsts_name="Gerance",
                        shop1_shp_invmod_name="Exclusif",
                        shop1_shp_com_ratio='',
                        shop1_shp_ctr_nbr="CT7104",
                        shop1_shp_lease_amount='',
                        shop1_shp_invoiced_flag="Y",
                        shop1_ctr_third_number="1805636",
                        shop1_shp_fr_ville="SEVRAN",
                        shop1_add_acc_name="Frederic MARTIN",
                        shop1_add_acc_way1='',
                        shop1_add_acc_way2="RESIDENCE ST DONAT",
                        shop1_add_acc_way3="5 CHEMIN ST DONAT",
                        shop1_add_acc_pos_pstare_code='',
                        shop1_add_acc_locality="AIX EN PROVENCE",
                        shop1_add_acc_phone_number_1="0651370730",
                        shop1_add_acc_country='',
                        shop1_shprsp_title="2",
                        shop1_shprsp_first_name="PEGGY",
                        shop1_shprsp_birthday="19811031",
                        shop1_ctr_effect_date="20141126",
                        shop1_shp_fiscal_close_date="20180331",
                        shop1_phydsc_fro_width_1="6.84",
                        shop1_phydsc_fro_width_2='',
                        shop1_phydsc_fro_width_3='',
                        shop1_cor_code="103424",
                        shop1_cor_lgl_type="SR",
                        shop1_cor_name="SARL APY.B BEAUTE",
                        shop1_cabin_qty="3",
                        shop1_rrspshp_resumption_date="20141126",
                        shop1_ctr_type_name="FRANCE CONTRAT V5 GL ANN2",
                        shop1_ctr_denunciation_date='',
                        shop1_ctr_royalties_cabin='',
                        shop1_ctr_deadline_preavis="20170524",
                        shop1_ech_datecomite='',
                        shop1_ech_decision='',
                        shop1_ech_dateservice='',
                        shop1_cau_number="10",
                        shop1_shp_certifie_flag='',
                        shop1_ctr_duration="3.0",
                        shop1_ctr_number_cabin='',
                        shop1_regdev_code='',
                        shop1_regdev_name='',
                        shop1_add_cou_code="FR",
                        shop1_add_del_way_1="CENTRE DE BEAUTE YVES ROCHER",
                        shop1_add_del_way_2="CENTRE COMMERCIAL CARREFOUR",
                        shop1_add_del_way_3="ROUTE DES PETITS PONTS",
                        shop1_add_del_pos_pstare_code="93270",
                        shop1_add_del_locality="SEVRAN",
                        shop1_add_del_loc_code='',
                        shop1_add_del_cou_code="FR",
                        shop1_add_del_country="France",
                        shop1_add_del_phone_number_1='',
                        shop1_trpreg_code="P1",
                        shop1_trpreg_name="Paris",
                        shop1_shp_ss_gen="60",
                        shop1_shp_ss_gen_lib="ACV",
                        shop1_lzn_code="75056",
                        shop1_lzn_name="Paris",
                        shop1_shp_fidprogram_accepted="1.0",
                        shor1_tim_cou_code='',
                        shor1_tim_shp_number='',
                        shor1_tim_weeday_code='',
                        shor1_tim_begin_morning='',
                        shor1_tim_end_morning='',
                        shor1_tim_begin_afternoon='',
                        shor1_tim_end_afternoon='',
                        ssct1_sec_cou_code='',
                        ssct1_sec_code='',
                        ssct1_sec_name='',
                        ssct1_seg_reg_code='',
                        ssct1_sec_organizer_code='',
                        ssct1_sec_people_tcb_code='',
                        ssct1_sec_people_name='',
                        srgn1_reg_cou_code='',
                        srgn1_reg_code='',
                        srgn1_reg_name='',
                        srgn1_reg_director_code='',
                        srgn1_reg_people_tcb_code='',
                        srgn1_reg_people_name='',
                        scfg1_mchfam_cou_code='',
                        scfg1_mchfam_shp_code='',
                        scfg1_mchfam_mcf_code='',
                        scfg1_mchfam_mcf_name='',
                        scfg1_mchfam_mchfam_code='',
                        scfg1_mchfam_mchfam_name='',
                        strs1_transf_cou_code='',
                        strs1_transf_shp_number='',
                        strs1_transf_code='',
                        strs1_transf_label='',
                        strs1_transf_open_date='',
                        strs1_transf_wor_begin='',
                        strs1_transf_wor_end_date='',
                        strs1_transf_tem_close='',
                        strs1_transf_ope_aft_work='',
                        strs1_transf_close_date='',
                        strs1_transf_activity_flag='',
                        strs1_transf_comment='',
                        strs1_transf_creation_date='',
                        sctr1_ctr_cou_code='',
                        sctr1_ctr_shp_number='',
                        sctr1_ctr_nbr='',
                        sctr1_ctr_sequence_nbr='',
                        sctr1_ctr_invmod_code='',
                        sctr1_ctr_effect_date='',
                        sctr1_ctr_end_date='',
                        sctr1_ctr_third_number='',
                        sctr1_ctr_code_type_gestion='',
                        sctr1_ctr_cor_name='',
                        sctd1_cou_code='',
                        sctd1_ctd_ctr_nbr='',
                        sctd1_ctd_ctr_sequence_nbr='',
                        sctd1_ctd_start_date='',
                        sctd1_ctd_end_date='',
                        sctd1_ctd_dis_code='',
                        sctd1_ctd_ctd_rate='',
                        sctt1_cou_code='',
                        sctt1_ctx_ctr_nbr='',
                        sctt1_ctx_ctr_sequence_nbr='',
                        sctt1_ctx_start_date='',
                        sctt1_ctx_end_date='',
                        sctt1_ctx_tax_code='',
                        sctt1_ctx_rate='',
                        sshr1_cou_code='',
                        sshr1_shp_number='',
                        sshr1_shprsp_code='',
                        sshr1_shprsp_dentry_date='',
                        sshr1_shprsp_end='',
                        sshr1_rrspshp_resumption_date='',
                        sshr1_shprsp_email='',
                        sshr1_shprsp_name='',
                        sshr1_shprsp_first_name='',
                        version_number="616",
                        source_file_name="REF_RES_LYR_YRFR_B_SHP_20190621104205.txt",
                        processing_time="2019-06-27 13 = 50 = 46.404 UTC"
                        )

        rows_generator = self.dofn.process(row_test, self.schema_dict_)

        row = rows_generator.next()
        # Tester type conforme
        self.assertIsInstance(row['prefixe'], str)
        self.assertIsInstance(row['shop1_rrspshp_dentry_date'], str)
        #self.assertIsInstance(row['sctd1_ctd_end_date'], str)
        self.assertIsInstance(row['shop1_shp_open_flag'], int)
        self.assertIsInstance(row["shop1_shp_tot_cust_area_population"], float)
        #self.assertIsInstance(row['shop1_shp_recre_date'], str)
        self.assertIsInstance(row['shop1_ind_shp_ins_dep'], bool)
        self.assertIsInstance(row['shop1_ind_shp_ins_dep_name'], str)
        self.assertIsInstance(row['source_file_name'], str)


    def test_format_columns_parse_exception(self):
        """
            test d'un enregistrement qui ne passe pas
            (psh_tva_prestation='B' alors que cette zone est float et
            psh_voucher_dscnt_rate='A' alors que cette zone est float )
        :return:
        """
        row_test = dict(prefixe="SHOP1",
                        shop1_cou_code="FR",
                        shop1_shp_number="0563",
                        shop1_shp_name="SEVRAN VILLEPINTE",
                        shop1_comimp_code="CC",
                        shop1_shp_main_number="0563",
                        shop1_indic_eq_lpg="F",
                        shop1_indic_top50="F",
                        shop1_indic_surface_egale='',
                        shop1_add_way_1='',
                        shop1_add_way_2="Route des Petits Ponts",
                        shop1_add_way_3="Centre Commercial Carrefour",
                        shop1_pos_pstare_code="93270",
                        shop1_add_locality="SEVRAN",
                        shop1_add_phone_number_1="0143102121",
                        shop1_cou_name="France",
                        shop1_cur_code="EU",
                        shop1_cur_name="Euro",
                        shop1_lan_code="FRA",
                        shop1_sec_code="22",
                        shop1_sec_name="Secteur 22",
                        shop1_sec_organizer_code=19,
                        shop1_reg_code="02",
                        shop1_reg_name="Nord",
                        shop1_reg_director_code="102",
                        shop1_shp_open_flag="1",
                        shop1_shp_test_flag='',
                        shop1_cou_code2="France",
                        shop1_shp_code="FR 0563",
                        shop1_ismcat_code="13",
                        shop1_shprsp_code="18183",
                        shop1_rrspshp_dentry_date="20141126",
                        shop1_ccl_email="sarlapybbeaute@gmail.com",
                        shop1_gesmod_code="8",
                        shop1_gesmod_lib="Gerance Exclusif",
                        shop1_shp_cur_generation="60",
                        shop1_shp_cur_generation_name="Meubles",
                        shop1_comimp_name="Centre commercial",
                        shop1_ismcat_name="CC banlieues pop",
                        shop1_ind_shp_ins_dep="true",
                        shop1_ind_shp_ins_dep_name='',
                        shop1_inst_dep="true",
                        shop1_mag_princ='',
                        shop1_weeday_name="dimanche",
                        shop1_genhis_date="20120822",
                        shop1_loc_retail_outlet_nbr="1.0",
                        shop1_loc_locality="SEVRAN",
                        shop1_acz_name="Zone C",
                        shop1_tou_label="Autre",
                        shop1_shp_tot_cust_area_population="141550.0",
                        shop1_shp_yr_tot_cust_area_popul='',
                        shop1_cust_area_type_name="Tres grande ville 100 - 300 000 habitants",
                        shop1_leader_sign_name="Carrefour",
                        shop1_sec_organizer_name="Sylvie JOLAK",
                        shop1_reg_directore_name="Isabelle DONAT",
                        shop1_shp_open_date="19841106",
                        shop1_shp_recre_date="19841106",
                        shop1_shp_trans_date='',
                        shop1_shp_exten_date='',
                        shop1_shp_renovation_date="20120625",
                        shop1_shp_close_date='',
                        shop1_shp_cur_rsp_name="BROCHARD PEGGY",
                        shop1_physdsc_sale_surface="73.45",
                        shop1_physdsc_cabin_surface="24.7",
                        shop1_tcbcfg_name="T13 =Config T11 + 2 postes d'encaissement supplementaires",
                        shop1_invmod_code="01",
                        shop1_lglsts_code="02",
                        shop1_shp_cur_dim="Y",
                        shop1_creation_date="20190621",
                        shop1_system_last_update="20190621",
                        shop1_loc_population_quantity="47029.0",
                        shop1_cust_area_type_code="04",
                        shop1_sitqlt_code='',
                        shop1_sitqlt_name='',
                        shop1_shp_numeris="0143102121",
                        shop1_shp_fax="0143102122",
                        shop1_shp_equivalent_effective="5.0",
                        shop1_shp_total_area="125.7",
                        shop1_shp_rsv_surface="7.3",
                        shop1_shp_window_number="2.0",
                        shop1_shp_window_width="3.32",
                        shop1_shp_floor_number="0.0",
                        shop1_shp_ctr_end_date="21001231",
                        shop1_shp_rent_amount='',
                        shop1_shp_lglsts_name="Gerance",
                        shop1_shp_invmod_name="Exclusif",
                        shop1_shp_com_ratio='',
                        shop1_shp_ctr_nbr="CT7104",
                        shop1_shp_lease_amount='',
                        shop1_shp_invoiced_flag="Y",
                        shop1_ctr_third_number="1805636",
                        shop1_shp_fr_ville="SEVRAN",
                        shop1_add_acc_name="Frederic MARTIN",
                        shop1_add_acc_way1='',
                        shop1_add_acc_way2="RESIDENCE ST DONAT",
                        shop1_add_acc_way3="5 CHEMIN ST DONAT",
                        shop1_add_acc_pos_pstare_code='',
                        shop1_add_acc_locality="AIX EN PROVENCE",
                        shop1_add_acc_phone_number_1="0651370730",
                        shop1_add_acc_country='',
                        shop1_shprsp_title="2",
                        shop1_shprsp_first_name="PEGGY",
                        shop1_shprsp_birthday="19811031",
                        shop1_ctr_effect_date="20141126",
                        shop1_shp_fiscal_close_date="20180331",
                        shop1_phydsc_fro_width_1="X",
                        shop1_phydsc_fro_width_2='',
                        shop1_phydsc_fro_width_3='',
                        shop1_cor_code="103424",
                        shop1_cor_lgl_type="SR",
                        shop1_cor_name="SARL APY.B BEAUTE",
                        shop1_cabin_qty="3",
                        shop1_rrspshp_resumption_date="20141126",
                        shop1_ctr_type_name="FRANCE CONTRAT V5 GL ANN2",
                        shop1_ctr_denunciation_date='',
                        shop1_ctr_royalties_cabin='',
                        shop1_ctr_deadline_preavis="20170524",
                        shop1_ech_datecomite='',
                        shop1_ech_decision='',
                        shop1_ech_dateservice='',
                        shop1_cau_number="10",
                        shop1_shp_certifie_flag='',
                        shop1_ctr_duration="Y",
                        shop1_ctr_number_cabin='',
                        shop1_regdev_code='',
                        shop1_regdev_name='',
                        shop1_add_cou_code="FR",
                        shop1_add_del_way_1="CENTRE DE BEAUTE YVES ROCHER",
                        shop1_add_del_way_2="CENTRE COMMERCIAL CARREFOUR",
                        shop1_add_del_way_3="ROUTE DES PETITS PONTS",
                        shop1_add_del_pos_pstare_code="93270",
                        shop1_add_del_locality="SEVRAN",
                        shop1_add_del_loc_code='',
                        shop1_add_del_cou_code="FR",
                        shop1_add_del_country="France",
                        shop1_add_del_phone_number_1='',
                        shop1_trpreg_code="P1",
                        shop1_trpreg_name="Paris",
                        shop1_shp_ss_gen="60",
                        shop1_shp_ss_gen_lib="ACV",
                        shop1_lzn_code="75056",
                        shop1_lzn_name="Paris",
                        shop1_shp_fidprogram_accepted="1.0",
                        shor1_tim_cou_code='',
                        shor1_tim_shp_number='',
                        shor1_tim_weeday_code='',
                        shor1_tim_begin_morning='',
                        shor1_tim_end_morning='',
                        shor1_tim_begin_afternoon='',
                        shor1_tim_end_afternoon='',
                        ssct1_sec_cou_code='',
                        ssct1_sec_code='',
                        ssct1_sec_name='',
                        ssct1_seg_reg_code='',
                        ssct1_sec_organizer_code='',
                        ssct1_sec_people_tcb_code='',
                        ssct1_sec_people_name='',
                        srgn1_reg_cou_code='',
                        srgn1_reg_code='',
                        srgn1_reg_name='',
                        srgn1_reg_director_code='',
                        srgn1_reg_people_tcb_code='',
                        srgn1_reg_people_name='',
                        scfg1_mchfam_cou_code='',
                        scfg1_mchfam_shp_code='',
                        scfg1_mchfam_mcf_code='',
                        scfg1_mchfam_mcf_name='',
                        scfg1_mchfam_mchfam_code='',
                        scfg1_mchfam_mchfam_name='',
                        strs1_transf_cou_code='',
                        strs1_transf_shp_number='',
                        strs1_transf_code='',
                        strs1_transf_label='',
                        strs1_transf_open_date='',
                        strs1_transf_wor_begin='',
                        strs1_transf_wor_end_date='',
                        strs1_transf_tem_close='',
                        strs1_transf_ope_aft_work='',
                        strs1_transf_close_date='',
                        strs1_transf_activity_flag='',
                        strs1_transf_comment='',
                        strs1_transf_creation_date='',
                        sctr1_ctr_cou_code='',
                        sctr1_ctr_shp_number='',
                        sctr1_ctr_nbr='',
                        sctr1_ctr_sequence_nbr='',
                        sctr1_ctr_invmod_code='',
                        sctr1_ctr_effect_date='',
                        sctr1_ctr_end_date='',
                        sctr1_ctr_third_number='',
                        sctr1_ctr_code_type_gestion='',
                        sctr1_ctr_cor_name='',
                        sctd1_cou_code='',
                        sctd1_ctd_ctr_nbr='',
                        sctd1_ctd_ctr_sequence_nbr='',
                        sctd1_ctd_start_date='',
                        sctd1_ctd_end_date='',
                        sctd1_ctd_dis_code='',
                        sctd1_ctd_ctd_rate='',
                        sctt1_cou_code='',
                        sctt1_ctx_ctr_nbr='',
                        sctt1_ctx_ctr_sequence_nbr='',
                        sctt1_ctx_start_date='',
                        sctt1_ctx_end_date='',
                        sctt1_ctx_tax_code='',
                        sctt1_ctx_rate='',
                        sshr1_cou_code='',
                        sshr1_shp_number='',
                        sshr1_shprsp_code='',
                        sshr1_shprsp_dentry_date='',
                        sshr1_shprsp_end='',
                        sshr1_rrspshp_resumption_date='',
                        sshr1_shprsp_email='',
                        sshr1_shprsp_name='',
                        sshr1_shprsp_first_name='',
                        version_number="616",
                        source_file_name="REF_RES_LYR_YRFR_B_SHP_20190621104205.txt",
                        processing_time="2019-06-27 13 = 50 = 46.404 UTC"
                        )

        # on teste si le retour dans le login comporte bien un message d'erreur
        with LogCapture() as logs:
            self.dofn.process(row_test, self.schema_dict_).next()
            list_logs = [logrecord.msg for logrecord in logs.records]
            self.assertIn('Format error on column "{}" with bad value "{}" and '
                          'Format error on column "{}"'
                          ' with bad value "{}"'.format('shop1_phydsc_fro_width_1',
                                                        'X', 'shop1_ctr_duration', 'Y',
                                                        ), list_logs)
